import numpy
import shared
import atomic_data


lj_e = None
lj_r = None

###=====================================================================================================================
def Set_Lennard_Jones_Parameters():
    global lj_e
    global lj_r

    lj_e = numpy.empty((shared.n_uniq_atom, shared.n_uniq_atom))
    lj_r = numpy.empty((shared.n_uniq_atom, shared.n_uniq_atom))

    for i1_atom in range(0, shared.n_uniq_atom):
        numb1 = shared.uniq_atom_numb[i1_atom]
        for i2_atom in range(i1_atom, shared.n_uniq_atom):
            numb2 = shared.uniq_atom_numb[i2_atom]
            lj_r[i1_atom,i2_atom] = atomic_data.atom_list[numb1].rmin + atomic_data.atom_list[numb2].rmin
            lj_r[i2_atom,i1_atom] = lj_r[i1_atom,i2_atom]
        #
    #
    lj_e[:,:] = 0.0
    lj_e[0,0] = 1.0
    lj_e[0,1] = 3.0
    lj_e[1,0] = 3.0
    lj_e[1,1] = 2.0

    print()
    for i1_atom in range(0, shared.n_uniq_atom):
        numb1 = shared.uniq_atom_numb[i1_atom]
        for i2_atom in range(i1_atom, shared.n_uniq_atom):
            numb2 = shared.uniq_atom_numb[i2_atom]
            print("%4i %4i     %4s(%2i) %4s(%2i)     %5.3f %5.3f     %5.3f     %5.3f" % (i1_atom, i2_atom, atomic_data.atom_list[numb1].symb, numb1, atomic_data.atom_list[numb2].symb, numb2, atomic_data.atom_list[numb1].rmin, atomic_data.atom_list[numb2].rmin, lj_r[i1_atom,i2_atom], lj_e[i1_atom,i2_atom]))
        #
    #
    print()
#

###=====================================================================================================================


