import os
import pickle

import shared


###=====================================================================================================================
def Save_Structures(struct_list, dirname, bests=False):
    xsfpath = os.path.join("%s" % (shared.work_path),
                           "generation_%4.4i" % (shared.i_generation + 1),
                           "strurctures", dirname, "xsf")
    if (not os.path.isdir(xsfpath)):
        os.makedirs(xsfpath)
    #
    for i_struct in range(0, len(struct_list)):
        filename = os.path.join(xsfpath, "structure_%4.4i.xsf" % (i_struct + 1))
        struct_list[i_struct].Save_XSF(filename)
    #

    if (bests):
        xsfpath = os.path.join("%s" % (shared.work_path),
                            "generation_%4.4i" % (shared.i_generation + 1),
                            "strurctures", dirname, "best_xsf")
        if (not os.path.isdir(xsfpath)):
            os.makedirs(xsfpath)
        #
        cwd = os.getcwd()
        os.chdir(xsfpath)
        for i_link in range(0, len(shared.best_energy_indx_array)):
            i_struct = shared.best_energy_indx_array[i_link]
            linkname = "best_%4.4i.xsf" % (i_link + 1)
            filename = os.path.join("..", "xsf", "structure_%4.4i.xsf" % (i_struct + 1))
            os.symlink(filename, linkname)
        #
        os.chdir(cwd)
    #

    pklpath = os.path.join("%s" % (shared.work_path),
                           "generation_%4.4i" % (shared.i_generation + 1),
                           "strurctures", dirname, "pickle")
    if (not os.path.isdir(pklpath)):
        os.makedirs(pklpath)
    #
    for i_struct in range(0, len(struct_list)):
        filename = os.path.join(pklpath, "structure_%4.4i.pkl" % (i_struct + 1))
        with open(filename, 'wb') as outf:
            pickle.dump(struct_list[i_struct], outf)
        #
    #


    fptpath = os.path.join("%s" % (shared.work_path),
                           "generation_%4.4i" % (shared.i_generation + 1),
                           "strurctures", dirname, "fingerprints")
    if (not os.path.isdir(fptpath)):
        os.makedirs(fptpath)
    #
    for i_struct in range(0, len(struct_list)):
        filename = os.path.join(fptpath, "fp_%4.4i.fpt" % (i_struct + 1))
        struct_list[i_struct].Save_Fingerprint(filename)
    #
#

###=====================================================================================================================


