import numpy
import math

import atomic_data


atom_numb = numpy.array([30] * 4, dtype=int)

restart_random_generator = False
relax = True

###=====================================================================================================================
sorted_atom_numb = numpy.sort(atom_numb)
n_atom = len(sorted_atom_numb)
(uniq_atom_numb, atom_id, uniq_atom_count) = numpy.unique(sorted_atom_numb, return_inverse=True, return_counts=True)
n_uniq_atom = len(uniq_atom_numb)

a = 10.0                    # in Angstrom
min_atomic_distance = 0.8   # in Angstrom
margin_factor = 1.10        # in unit of a

initial_indiv = None
final_indiv   = None
i_indiv       = None
gen_indiv     = []

n_indiv = 10
n_indiv_init = 10
n_generation = 10
max_relaxation_time = 3   # seconds

n_swap_max  = 1
n_shift_max = 2

min_conv_fraction               = 0.60
death_fraction                  = 0.40
surviving_fraction              = 0.15
crossing_fraction               = 0.40 # 0.50
slice_mutation_fraction         = 0.15 # 0.10
atom_type_mutation_fraction     = 0.15 # 0.10
atom_position_mutation_fraction = 0.15 # 0.10

n_indiv_max  = max(n_indiv, n_indiv_init, int(n_indiv*(1+surviving_fraction)))

work_path = "workspace"
i_generation = None


energy_array           = None
energy_indx_array      = None
best_energy_indx_array = None

n_death                  = None
n_live                   = None
n_live_uniq              = None
n_surviving              = None
n_crossing               = None
n_slice_mutation         = None
n_atom_type_mutation     = None
n_atom_position_mutation = None
n_random                 = None


fingerprint_delta     = 0.040
fingerprint_sigma     = 0.020
fingerprint_threshold = 0.020

n_try_fill_max                   = 100
n_try_crossing_max               =  20
n_try_slice_mutation_max         =  20
n_try_atom_type_mutation_max     =  20
n_try_atom_position_mutation_max =  20
n_try_random_max                 =  20

n_try_fill                   = 0
n_try_crossing               = 0
n_try_slice_mutation         = 0
n_try_atom_type_mutation     = 0
n_try_atom_position_mutation = 0
n_try_random                 = 0

n_r_array = None
r_array   = None
fingerprint_archive = []

lj_r_factor = 1.0

########################################################################################################################
radius_array = numpy.array([atomic_data.atom_list[numb].rmin for numb in uniq_atom_numb])
radius_max   = max(radius_array)
margin = 2 * radius_max * margin_factor
if (margin > a / 2):
    print(":ERROR:   !!!   The given cell side (a) is too short for the given margin_factor.")
    exit()
#

total_atomic_volume   = numpy.sum(4.0 / 3 * math.pi * radius_array ** 3 * uniq_atom_count)
effective_cell_volume = (a - 2 * margin) ** 3
if (total_atomic_volume > effective_cell_volume * 2):
    print(":ERROR:   !!!   The given cell side (a) is too short for the given atoms.")
    exit()
#
margin = margin / a









